const Log = require("tp-log");
let DB;
try {
    DB = require("tp-db");
} catch (e) {}

module.exports.throw = function(message, err) {
    Log.error(message, err);
    new Error(message, err);

    if(DB) {
        DB.req("mongo", "errors", "new", new Error(message, err), function(err) {
            if (err) {
                console.error("Unable to save error report in database.");
                console.error(err);
                callback(err);
            } else {
                callback(null);
            }
        })
    }
};

module.exports.clear = function(callback) {
    if(DB) {
        DB.req("mongo", "errors", "clear",{}, function(err) {
            if (err) {
                console.error("Unable to clear error reports in database.");
                console.error(err);
                callback(err);
            } else {
                callback(null);
            }
        })
    }
};

module.exports.get = function() {
    if(DB) {
        DB.req("mongo", "errors", "get",{}, function(err, errors) {
            if (err) {
                console.error("Unable to fetch error reports from the database.");
                console.error(err);
                callback(err);
            } else {
                callback(errors);
            }
        })
    }
};

function Error(message, err) {
    this.message = message;
    this.err = err;
    this.date = new Date();
}